//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT

//
//
//
//
//

extern string StPeriods       = "10;15;20;";
extern string StMultipliers   = "1.7;1.7;1.7;";
extern string StTimeFrames    = "0;0;0;";

//
//
//
//
//

double Buffer0[];
double Buffer1[];

bool   returnBars;
string indicatorFileName;

int    size;
double periods[];
double multipliers[];
double timeframes[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,Buffer0);
   SetIndexBuffer(1,Buffer1);

      //
      //
      //
      //
      //
      
         if (StringSubstr(StPeriods,StringLen(StPeriods)-1,1) != ";")
                          StPeriods = StringConcatenate(StPeriods,";");
            int s = 0;
            int i = StringFind(StPeriods,";",s);
            double current;
               while (i > 0)
               {
                  current = StrToDouble(StringSubstr(StPeriods,s,i-s));
                  if (current > 0) {
                        ArrayResize(periods,ArraySize(periods)+1);
                                    periods[ArraySize(periods)-1] = current; }
                                    s = i + 1;
                                        i = StringFind(StPeriods,";",s);
               }
               size = ArraySize(periods);

         //
         //
         //
         //
         //
      
         if (StringSubstr(StMultipliers,StringLen(StMultipliers)-1,1) != ";")
                          StMultipliers = StringConcatenate(StMultipliers,";");
            s = 0;
            i = StringFind(StMultipliers,";",s);
               while (i > 0)
               {
                  current = StrToDouble(StringSubstr(StMultipliers,s,i-s));
                  if (current > 0) {
                        ArrayResize(multipliers,ArraySize(multipliers)+1);
                                    multipliers[ArraySize(multipliers)-1] = current; }
                                    s = i + 1;
                                        i = StringFind(StMultipliers,";",s);
               }
               
         //
         //
         //
         //
         //
                        
         if (StringSubstr(StTimeFrames,StringLen(StTimeFrames)-1,1) != ";")
                          StTimeFrames = StringConcatenate(StTimeFrames,";");
            s = 0;
            i = StringFind(StTimeFrames,";",s);
               while (i > 0)
               {
                  current = stringToTimeFrame(StringSubstr(StTimeFrames,s,i-s));
                  if (current > 0) {
                        ArrayResize(timeframes,ArraySize(timeframes)+1);
                                    timeframes[ArraySize(timeframes)-1] = current; }
                                    s = i + 1;
                                        i = StringFind(StTimeFrames,";",s);
               }


      //
      //
      //
      //
      //

         indicatorFileName = WindowExpertName();
         returnBars        = StPeriods=="returnBars";  if (returnBars) return(0);

   IndicatorShortName("supertrend rayphua");
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Buffer0[0] = MathMin(limit+1,Bars-1); return(0); }
         for (int k=0; k<size; k++)
            if (timeframes[k]!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeframes[k],indicatorFileName,"returnBars",0,0)*timeframes[k]/Period()));
         

   //
   //
   //
   //
   //
   //

      for(int i=limit; i >= 0; i--)
      {
         double max = EMPTY_VALUE;
         double min = EMPTY_VALUE;
         for (k=0; k<size; k++)
         {
            int y = iBarShift(NULL,timeframes[k],Time[i]);
               double st = iCustom(NULL,timeframes[k],"SuperTrendXAlertsMtf","","",periods[k],multipliers[k],0,y);
               if (k==0)
               {
                  max=st; 
                  min=st;
               }
               else
               {
                  max = MathMax(st,max);
                  min = MathMin(st,min);
               }                  
         }
         Buffer0[i] = max;
         Buffer1[i] = min;
      }         
      return(0);
}
   

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}